Attribute VB_Name = "StruttureBMP"
'================================================================
' Descrizione.....: Strutture, tipi e costanti, piu' comunemente
'                   usati, per trafficare con BMP (Ref: Bmp.txt).
'                   API per la creazione e la gestione dei DIB.
' Nome dei Files..: StruttureBMP.bas
' Data............: 5/11/2000
' Versione........: 1.0 a 32 bits
' Sistema.........: Visual Basic 6.0
'                   sotto Windows NT 4.0 (SP 3).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
'================================================================
'
Option Explicit
'------------------------------------------------------------------------------------
'
'   For Windows 3.0:
'    BITMAPFILE{
'       BITMAPFILEHEADER        bmfHeader
'       BITMAPINFO{             bi
'           BITMAPINFOHEADER    bmiHeader
'           RGBQUAD()           bmiColors
'       }
'       BYTE()                  Pixels
'    }
'
Public Type BITMAPFILEHEADER_Type
    bfType          As String * 2   ' The string BM (hex value &H424D).
    bfSize          As Long         ' The size of the file, measured in [Bytes].
    bfReserved1     As Integer      ' Not used, set to zero.
    bfReserved2     As Integer      ' Not used, set to zero.
    bfOffBits       As Long         ' The start offset of the bitmap data in the file.
End Type
'
Private Type BITMAPINFOHEADER_Type
    biSize          As Long         ' 40 (the size of this structure).
    biWidth         As Long         ' The width of the bitmap in pixels.
    biHeight        As Long         ' The height of the bitmap in pixels.
    biPlanes        As Integer      ' 1 (DIBs always have one plane).
    biBitCount      As Integer      ' 1 for monochrome, 4 for 16 colors,
                                    ' 8 for 256 color, 24 for 24-bit RGB color.
    biCompression   As Long         ' Specifies the type of compression for compressed
                                    ' bitmap. It can be one of the following values:
                                    ' BI_RGB:   BitMap is not compressed.
                                    ' BI_RLE8:  encoded format with 8 [BitsPerPixel].
                                    ' BI_RLE4:  encoded format with 4 [BitsPerPixel].
    biSizeImage     As Long         ' The size of the image in bytes.
                                    ' May be zero if biCompression is BI_RGB.
    biXPelsPerMeter As Long         ' Number of horizontal pixels per meter for
                                    ' which this DIB was designed.
    biYPelsPerMeter As Long         ' Number of vertical pixels per meter for
                                    ' which this DIB was designed.
    biClrUsed       As Long         ' Number of entries in the DIB color table
                                    ' that are actually used. Zero if all are used.
                                    ' Must be zero or the actual color table size
                                    ' for packed DIBs
    biClrImportant  As Long         ' Number of entries in the DIB color table that
                                    ' are important. Zero to specify all colors.
End Type
'
Private Type RGBQUAD_Type
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
'
Public Type BITMAPINFO_Type
    bmiHeader As BITMAPINFOHEADER_Type
    bmiColors(0 To 255) As RGBQUAD_Type ' E' dimensionato al massimo numero
                                        ' possibile di colori perche' l' uso
                                        ' di array dinamici non e' consentito
                                        ' nell' API GetDIBits.
End Type
'
Private Type BITMAP_Type
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type
'
'------------------------------------------------------------------------------------
'
'   For OS/2 Presentation Manager:
'    BITMAPFILE{
'       BITMAPFILEHEADER        bmfHeader
'       BITMAPCOREINFO{         bci
'           BITMAPCOREHEADER    bmciHeader
'           RGBTRIPLE()         bmciColors
'       }
'       BYTE()                  Pixels
'    }
'
Private Type BITMAPCOREHEADER_Type
    bcSize          As Long         ' 12 (the size of this structure).
    bcWidth         As Integer      ' The width of the bitmap in pixels.
    bcHeight        As Integer      ' The height of the bitmap in pixels.
    bcPlanes        As Integer      ' 1 (DIBs always have one plane).
    bcBitCount      As Integer      ' 1 for monochrome, 4 for 16 colors,
                                    ' 8 for 256 color, 24 for 24-bit RGB color.
End Type
'
Private Type RGBTRIPLE_Type
    rgbtBlue As Byte
    rgbtGreen As Byte
    rgbtRed As Byte
End Type
'
Private Type BITMAPCOREINFO_Type
    bmciHeader As BITMAPINFOHEADER_Type
    bmciColors() As RGBTRIPLE_Type
End Type
'
'------------------------------------------------------------------------------------
Public Const BI_RGB& = 0&
Private Const BI_RLE8& = 1&
Private Const BI_RLE4& = 2&
'
'------------------------------------------------------------------------------------
Public Type RECT_Type
    Left  As Long
    Top  As Long
    Right  As Long
    Bottom  As Long
End Type
'
' DC related API
Public Declare Function CreateCompatibleDC Lib "gdi32" _
(ByVal hDC As Long) As Long
Public Declare Function GetWindowDC Lib "user32" _
(ByVal hWnd As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" _
(ByVal hDC As Long) As Long
'
' Graphics related API
Public Const DIB_RGB_COLORS& = 0
Private Const DIB_PAL_COLORS& = 1
'
Public Declare Function GetDIBits Lib "gdi32" _
(ByVal hDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long _
, ByVal nNumScans As Long, ByVal lpBits As Long _
, BITMAPINFO As BITMAPINFO_Type, ByVal wUsage As Long) As Long
'
' General attribute related API
Public Declare Function GetClientRect Lib "user32" _
(ByVal hWnd As Long, lpRect As RECT_Type) As Long
'
' Memory allocation related API
Public Const GMEM_MOVEABLE& = 2
'
Public Declare Function GlobalAlloc Lib "kernel32" _
(ByVal wFlags As Long, ByVal lMem&) As Long
Public Declare Function GlobalLock Lib "kernel32" _
(ByVal hMem As Long) As Long
Public Declare Function GlobalUnlock Lib "kernel32" _
(ByVal hMem As Long) As Long
Public Declare Function GlobalFree Lib "kernel32" _
(ByVal hMem As Long) As Long
'
Public Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" _
(pDest As Any, pSource As Any, ByVal dwLength As Long)

